UNIT UI_Test_Frame_in_DLL;
{$mode objfpc}{$H+}
{$Define Library }
INTERFACE
USES
    Classes
  , Sysutils
  , Forms
  , Controls
  , Graphics
  , Dialogs
  , ComCtrls
  , ExtCtrls
  , StdCtrls
{$IFDef Library }
{$Else}
  , UTST_TS_Collector
{$EndIF }
  ;

TYPE
  TTST_Form_Frame_in_DLL = CLASS ( Tform )
      BTN_Band: Tbutton;
      BTN_Musiker: Tbutton;
      Pagecontrol1: TPageControl;
      PNL_Page: Tpanel;
      PNL_ToolBar: Tpanel;
      TS_Band: TTabSheet;
      TS_Musiker: TTabSheet;
      PROCEDURE Btn_bandclick ( Sender: Tobject ) ;
      PROCEDURE Btn_musikerclick ( Sender: Tobject ) ;
      PROCEDURE Formdestroy ( Sender: Tobject ) ;
      PROCEDURE Form_Create ( Sender: Tobject ) ;
      PROCEDURE Form_Activate ( Sender: Tobject ) ;
    PRIVATE
    PUBLIC

  END;

TYPE
  TPDLL_Init_Application  = PROCEDURE( io_Value : TApplication ); CDECL;
  TPDLL_ADD_TabSheet      = PROCEDURE( io_Owner : TComponent; iv_Name : String; iv_Color : TColor ); CDECL;
  TFDLL_ACTIVATE_TabSheet = FUNCTION( iv_Name : String ) : Boolean; CDECL;

VAR
  go_LibHdl : TLibHandle;
  TST_Form_Frame_in_DLL: TTST_Form_Frame_in_DLL;
  GV_Register_TS : TPDLL_ADD_TabSheet;
  gv_Activate_TS : TFDLL_ACTIVATE_TabSheet;
  gv_Init_Appl   : TPDLL_Init_Application;


IMPLEMENTATION
{$R *.lfm}


PROCEDURE Ttst_form_frame_in_dll.Form_Create ( Sender: Tobject ) ;
BEGIN
{$IFDef Library }
  gv_Init_Appl   :=  TPDLL_Init_Application( GetProcedureAddress ( go_LibHdl ,  'Register_Application' ) );
  GV_Register_TS :=  TPDLL_ADD_TabSheet( GetProcedureAddress ( go_LibHdl ,  'ADD_TabSheet' ) );
  GV_Activate_TS :=  TFDLL_ACTIVATE_TabSheet ( GetProcedureAddress ( go_LibHdl ,  'ACTIVATE_TabSheet' ) );
{$EndIF }
END;

PROCEDURE Ttst_form_frame_in_dll.Formdestroy ( Sender: Tobject ) ;
BEGIN
  //
END;



{===================================================================================================
===================================================================================================}
PROCEDURE Ttst_form_frame_in_dll.Form_Activate ( Sender: Tobject ) ;
BEGIN
{$IFDef Library }
  gv_Init_Appl( Application );
  GV_Register_TS( PNL_Page, 'Band', clLime );
  GV_Register_TS( PNL_Page, 'Musiker', clYellow );
{$Else }
  GO_Obj_List.ADD_TabSheet( PNL_Page, 'Band', clLime );
  GO_Obj_List.ADD_TabSheet( PNL_Page, 'Musiker', clYellow );
{$EndIF }
END;



{===================================================================================================
===================================================================================================}
PROCEDURE Ttst_form_frame_in_dll.Btn_bandclick ( Sender: Tobject ) ;
BEGIN
{$IFDef Library }
  gv_Activate_TS('Band');
{$Else }
  GO_Obj_List.ACTIVATE_TabSheet( 'Band' );
{$EndIF }

END;


{===================================================================================================
===================================================================================================}
PROCEDURE Ttst_form_frame_in_dll.Btn_musikerclick ( Sender: Tobject ) ;
BEGIN
{$IFDef Library }
  gv_Activate_TS('Musiker');
{$Else }
  GO_Obj_List.ACTIVATE_TabSheet( 'Musiker' );
{$EndIF }
End;



{$IFDef Library }
INITIALIZATION
  go_LibHdl := LoadLibrary( 'DLL_Test_Frame.dll' );
{$EndIF }

END.

